diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_decode.p.orig v15.6301-amd64/pop/packages/vedmail/auto/ved_decode.p.orig
--- pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_decode.p.orig	2005-07-11 17:02:28.000000000 -0400
+++ v15.6301-amd64/pop/packages/vedmail/auto/ved_decode.p.orig	2007-02-12 12:28:25.000000000 -0500
@@ -1,4 +1,4 @@
-/* --- Copyright University of Birmingham 2005. All rights reserved. ------
+/* --- Copyright University of Birmingham 2007. All rights reserved. ------
  > File:            $poplocal/local/auto/ved_decode.p
  > Purpose:			Decode attachment in mail file
  > Author:          Aaron Sloman, Mar 23 1998 (see revisions)
@@ -50,6 +50,7 @@
 
 define decode_file_into(command, infile, outfile);
 	;;; use `%` option in case path names include '~'
+	;;; Veddebug([decoding %infile% to %outfile%]);
 	sysobey(command >< infile >< ' > ' >< outfile);
 	;;; Veddebug([decoded to %outfile%]);
 enddefine;
@@ -100,6 +101,9 @@
 	doctype  = '.doc',
 	sdwtype  = '.sdw', 	;;; staroffice/openoffice
 	sxwtype  = '.sxw', 	;;; staroffice/openoffice
+	odttype	 = '.odt',	;;; OpenDocument Text
+	odstype	 = '.ods',	;;; OpenDocument Spreadsheet
+	odptype	 = '.odp',	;;; OpenDocument Presentation
 	xlstype  = '.xls',
 	wpdtype  = '.wpd',
 	bmptype  = '.bmp',
@@ -132,10 +136,8 @@
 	no_decode_types =
 	[^pstype ^htmltype ^htmtype ^texttype ^txttype ^latextype ^bibtype ^rtftype
 			^mpegtype ^mpgtype ^avitype ^pcxtype ^false],
-	pcv_types =
-	[^ppttype ^doctype ^xlstype ^wpdtype ^rtftype ^sdwtype ^sxwtype],
 	soffice_types =
-	[^ppttype ^doctype ^xlstype ^htmltype ^sdwtype ^sxwtype],
+	[^ppttype ^doctype ^xlstype ^htmltype ^sdwtype ^sxwtype ^odttype ^odstype ^odptype],
 	pdf_types = [^pdftype],
 	netscape_types =
 	[^pstype ^htmltype ^pdftype],
@@ -220,6 +222,7 @@
 		vvedlinesize == 0
 		or issubstring('content', (uppertolower(vedthisline()) ->> textline))
 		or issubstring('decoding', textline)
+		or issubstring('attachment', textline)
 		;;; next two deal with wrapped lines due to editing name field, etc.
 		or isstartstring('charset=', textline)
 		or isstartstring('name=', textline)
@@ -271,11 +274,12 @@
 			show_output_on_status = false,
 			vedargument = all_files;
 
+		;;; Veddebug('showing ' <> all_files);
 		vedgenshell('/bin/sh', '');
 		vedtopfile();
 		vedlineabove();
 		vedinsertstring('NEW FILE(S) CREATED. DELETE IF NOT WANTED');
-		;;; Veddebug('shown ' <> files);
+		;;; Veddebug('shown ' <> all_files);
 		unless oldfile = vedcurrentfile then
 			oldfile -> ved_current_file
 		endunless;
@@ -284,7 +288,7 @@
 
 define lconstant delete_coded(file);
 	dlocal ved_current_file;
-	;;; Veddebug('Check deleting in ' >< vedpathname);
+	;;;Veddebug('Check deleting in ' >< vedpathname);
 	if getanswer('Delete attachment from message?(y/n)') then
 		lvars oldfile = vedcurrentfile;
 		file -> ved_current_file;
@@ -293,7 +297,7 @@
 		ved_d();
 		oldfile -> ved_current_file;
 	endif;
-
+    ;;;Veddebug('No delete: '>< file);
 enddefine;
 
 define Isstartstring(string, item);
@@ -476,7 +480,10 @@
 		;;; filetype already known.
 	elseif getanswer('Is it a DOC (Word) file? (y/n)') then
 		doctype -> filetype
-	elseif getanswer('Is it a SDW (StarOffice) file? (y/n)') then
+	elseif getanswer('Just save file? (y/n)') then
+		;;; treat as unknown.
+		anytype -> filetype;
+	 elseif getanswer('Is it a SDW (StarOffice) file? (y/n)') then
 		sdwtype -> filetype
 	elseif getanswer('Is it a SXW (StarOffice) file? (y/n)') then
 		sxwtype -> filetype
@@ -535,6 +542,7 @@
 		or Issubstring('.gif"', content_type)) then
 		giftype -> filetype;
 	elseif (Issubstring('image/tif', content_type)
+		or Issubstring('image/tiff', content_type)
 		or Isendstring(tiftype, file_name)
 		or Issubstring('.tif"', content_type)) then
 		tiftype -> filetype;
@@ -575,6 +583,12 @@
 		sxwtype -> filetype;
 	elseif Isendstring(sdwtype, file_name) then
 		sdwtype -> filetype;
+	elseif Isendstring(odttype, file_name) then
+		odttype -> filetype;
+	elseif Isendstring(odstype, file_name) then
+		odstype -> filetype;
+	elseif Isendstring(odptype, file_name) then
+		odptype -> filetype;
 	elseif Issubstring('text/richtext', content_type)
 		or Isendstring(rtftype, file_name)
 	then
@@ -595,10 +609,6 @@
 		or Isendstring(ppttype, file_name)
 	then
 		ppttype -> filetype;
-	elseif Issubstring('latex', content_type)
-		or Isendstring(latextype, file_name)
-	then
-		latextype -> filetype;
 	elseif Isendstring(dvitype, file_name) then
 		dvitype -> filetype;
 	elseif Issubstring('bibtex', content_type)
@@ -624,10 +634,13 @@
 	elseif Issubstring('text/plain', content_type)
 		or Issubstring('message/rfc822', content_type)
 		or Isendstring(texttype, file_name)
+		or Isendstring(txttype, file_name)
 	then
-		texttype -> filetype;
-	elseif Isendstring(txttype, file_name) then
-		txttype -> filetype;
+		if Isendstring(txttype, file_name) then
+			txttype -> filetype;
+		else
+			texttype -> filetype;
+		endif
 	elseif Isendstring(exetype, file_name) then
 		exetype -> filetype;
 	elseif Isendstring(pltype, file_name) then
@@ -652,14 +665,18 @@
 			sxwtype -> filetype;
 	elseif Issubstring(sdwtype, file_name) then
 			sdwtype -> filetype;
+	elseif Issubstring(odptype, file_name) then
+			odptype -> filetype;
+	elseif Issubstring(odstype, file_name) then
+			odstype -> filetype;
+	elseif Issubstring(odttype, file_name) then
+			odttype -> filetype;
 	elseif Issubstring(wpdtype, file_name) then
 			wpdtype -> filetype;
 	elseif Issubstring(pdftype, file_name) then
 			pdftype -> filetype;
 	elseif Issubstring(rtftype, file_name) then
 			rtftype -> filetype;
-	elseif Issubstring(latextype, file_name) then
-			latextype -> filetype;
 	elseif Issubstring(htmltype, file_name)
 		or Issubstring(htmtype, file_name) then
 			htmltype -> filetype;
@@ -669,6 +686,13 @@
 			tgztype -> filetype;
 	elseif Issubstring(ziptype, file_name) then
 			ziptype -> filetype;
+	;;; next one should be after zip and gz
+	elseif Issubstring('latex', content_type)
+		or Isendstring(latextype, file_name)
+	then
+		latextype -> filetype;
+	elseif Issubstring(latextype, file_name) then
+			latextype -> filetype;
 	elseif Issubstring(jartype, file_name) then
 			jartype -> filetype;
 	else
@@ -707,8 +731,10 @@
 enddefine;
 
 define process_html(savedfile, lynx_path);
+	;;; Veddebug('SAVED: ' >< savedfile);
 	lvars
-		basename = sys_fname_path(savedfile)dir_><sys_fname_nam(savedfile);
+		basename = sys_fname_path(savedfile)dir_><sys_fname_nam(savedfile),
+		type = sys_fname_extn(savedfile);
 
 	;;; If lynx available, then get text version
 	;;; Veddebug(' checking for html');
@@ -718,10 +744,13 @@
 		show_info(finalname);
 		finalname -> savedfile;
 	else
-		;;; Veddebug('About to show ' <> savedfile);
+		;;;Veddebug('Show_info: ' >< savedfile);
 		show_info(savedfile)
 	endif;
-	edit(savedfile);
+	if member(type, text_types) then
+		;;; Veddebug(['About to edit' ^savedfile]);
+		edit(savedfile);
+	endif;
 enddefine;
 
 define process_qp(savedfile, quoted_printable, lynx_path) -> savedfile;
@@ -742,11 +771,13 @@
 		;;; Veddebug([running: ^mime_decode_quoted_printable_command]);
 		decode_file_into(mime_decode_quoted_printable_command, savedfile, newnewname);
         ;;; qp encoded file is generally not worth saving
-		;;; Veddebug([DELETING ^savedfile]);
+		;;; Veddebug([DELETING QP file ^savedfile]);
 		sysdelete(savedfile) ->;
 		newnewname -> savedfile;
 	endif;
+	;;;; Veddebug([show_info ^savedfile]);
 	show_info(savedfile);
+	;;; Veddebug([process_html ^savedfile]);
 	process_html(savedfile, lynx_path);
 enddefine;
 
@@ -790,7 +821,7 @@
 		return;
 	endif;
 	
-	;;;Veddebug('savedir '>< savedir);
+	;;; Veddebug('savedir '>< savedir);
 
 	if member(savedir, ['/var/mail/' '/var/spool/mail/' '/usr/spool/mail/']) then
 		;;; if reading system mail file, store files in user's mail directory,
@@ -894,6 +925,7 @@
 		if issubstring(qp_field, content_transfer_encoding) then
 			true -> quoted_printable;
 		elseif issubstring('base64', content_transfer_encoding) then
+			;;; Veddebug('ENCODING: ' >< content_transfer_encoding);
 			true -> mimencoded;
 			mimetype -> saved_file_type;
 		elseif isstartstring('7bit', content_transfer_encoding)
@@ -910,10 +942,12 @@
 			;;; not sure this is possible
 			true -> rtfcoded;
 			rtftype -> saved_file_type;
+		else
+			'undefined' -> saved_file_type;
 		endif;
 	endif;
 	;;; Veddebug('qp type ' >< quoted_printable);
-	;;; Veddebug('saved file type ' >< saved_file_type);
+	;;; Veddebug(['saved file type '  ^saved_file_type]);
 
 	;;; Find out type (suffix) of ultimate file to be saved
 	;;; e.g. after decoding
@@ -935,6 +969,7 @@
 	markmime_contents();
 
 	;;; now should have filetype, content_transfer_encoding, content_type, file_name etc.
+	;;; Veddebug([saved_file_type ^saved_file_type]);
 
 	lvars string = vedthisline();
 	;;; find out if it is uuencoded
@@ -971,7 +1006,7 @@
 		ppttype -> saved_file_type;
 	else
 		;;; use null string as type, by default
-		;;; vederror('Unknown coding type')
+		vederror('Unknown coding type')
 	endif;
 
 	;;; Veddebug('Revised saved file type ' >< saved_file_type);
@@ -988,14 +1023,14 @@
 	;;; Veddebug([filetype ^filetype saved ^saved_file_type]);
 
 	if member(filetype, no_decode_types) and
-		saved_file_type = texttype then
+		(saved_file_type = texttype or saved_file_type = txttype) then
 		;;; don't add file suffix
 
 	elseunless Isendstring(saved_file_type, savedfile) then
 		;;; empty type works OK
 		;;; see if it is necessary to add a suffix.
 		lvars suff = uppertolower(sys_fname_extn(savedfile));
-		
+	
 		savedfile >< saved_file_type-> savedfile;
 	endif;
 	if quoted_printable then savedfile<>'-qp' -> savedfile endif;
@@ -1028,6 +1063,8 @@
 		else savedpath >< filetype
 		endif -> decodedfile;
 
+		;;; Veddebug('DECODEDNAME: ' >< decodedfile);
+
 		unless Isendstring(filetype, decodedfile) then
 			decodedfile >< filetype -> decodedfile;
 		endunless;
@@ -1039,6 +1076,7 @@
 			;;; remove crlf from text files sent by PC users
 			decode_file_into(mime_decode_and_crlf_command, savedfile, decodedfile);
 		else
+			;;; Veddebug('decoding non text_type: ' >< filetype);
 			decode_file_into(mime_decode_command, savedfile, decodedfile);
 		endif;
 
@@ -1048,15 +1086,14 @@
 			if decode_protect then 'chmod 640 ' else 'chmod 644 '
 			endif >< decodedfile);
 
-		;;; work out length of file excluding last 22 chars
-		lvars len = max(0, datalength(savedfile) - 22);
-
+		;;; work out length of file name excluding last 22 chars
+		;;; lvars len = max(0, datalength(savedfile) - 22);
 		;;; Ask if the original and mime file should be deleted, and show the results.
 		;;; if getanswer('Decoded! Delete mime file (...' <> allbutfirst(len, savedfile) <>') y/n?') then
 		vedputmessage('Decoded! Deleting mime file');
         syssleep(50);
 		sysdelete(savedfile) ->;
-			false -> savedfile;
+		false -> savedfile;
 		;;; else
 		;;;	show_info(savedfile)
 		;;; endif;
@@ -1068,8 +1105,12 @@
 			true -> deleteasked;
 		endunless;
 
+		;;;; Veddebug('Decoded: ' >< decodedfile);
+
 		;;; Attempt some processing, or advice for user
 		if member(filetype, text_types) then
+			;;; Altered. AS 23 Nov 2006
+			;;; process_html(savedfile, lynx_path);
 			process_html(decodedfile, lynx_path);
 			if isendstring(htmltype, decodedfile) then
 				if do_not_display_file then
@@ -1107,18 +1148,19 @@
 				vedlinebelow();
 			endif;
 			endlblock;
-		elseif filetype = sdwtype or filetype = sxwtype then
-			;;; try to decode StarOffice/OpenOffice file. Probably won't work
-			veddo(lhalw_command >< decodedfile);
-			;;; Rename output
-			veddo('name ' <> decodedfile >< texttype);
-			ved_w1();
-			show_info(vedpathname);
-			vedtopfile();
-			vedlinebelow();
-			vedinsertstring('RESULT OF DECODING BY LHALW: EDIT AS NEEDED');
-			vedlinebelow();
+;;; 		elseif filetype = sdwtype or filetype = sxwtype then
+;;; 			;;; try to decode StarOffice/OpenOffice file. Probably won't work
+;;; 			veddo(lhalw_command >< decodedfile);
+;;; 			;;; Rename output
+;;; 			veddo('name ' <> decodedfile >< texttype);
+;;; 			ved_w1();
+;;; 			show_info(vedpathname);
+;;; 			vedtopfile();
+;;; 			vedlinebelow();
+;;; 			vedinsertstring('RESULT OF DECODING BY LHALW: EDIT AS NEEDED');
+;;; 			vedlinebelow();
 		elseif member(filetype, text_types) then
+			;;; Veddebug(['Reading in ' ^decodedfile]);
 			veddo('ved ' >< decodedfile);
 		elseif filetype = pstype then
 			vedputmessage('Try ghostview to view');
@@ -1189,6 +1231,9 @@
 		endunless;
 		;;; showfiles();
 		;;; return();
+	else
+		;;; Veddebug([Uncategorised ^filetype]);
+		vederror('Uncategorised type: ' >< filetype);
 	endif;
 
 	vedcheck();
@@ -1214,14 +1259,10 @@
 		and getanswer('Try netscape? (y/n)') then
 			veddo('bg netscape ' <> displayfile);
 			vedputmessage('netscape launched. Please wait')
-		elseif DISPLAY and member(filetype, pcv_types)
-		and getanswer('Try PcFileViewer? (y/n)') then
-			veddo('bg /bham/ums/solaris/com/bin/pcv ' <> displayfile);
-			vedputmessage('Viewer launched. Please wait')
 		elseif DISPLAY and member(filetype, soffice_types)
-		and getanswer('Try StarOffice? (y/n)') then
+		and getanswer('Try StarOffice? OpenOffice (y/n)') then
 			veddo('bg soffice ' <> displayfile);
-			vedputmessage('Star Office launched. Please wait')
+			vedputmessage('Star/Open Office launched. Please wait')
 		elseif DISPLAY and member(filetype, pdf_types)
 		and getanswer('Try acroread? (y/n)') then
 			veddo('bg acroread ' <> displayfile);
@@ -1239,6 +1280,31 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Feb 12 2007
+	Moved latex type to later, incase it clashes with something
+	like Zip type.
+--- Aaron Sloman, Nov 23 2006
+	Altered find_file_type to keep '.txt' for files that already	
+	have that.
+
+	Replaced
+			process_html(savedfile, lynx_path);
+	with
+			process_html(decodedfile, lynx_path);
+
+	Commented out more calls of Veddebug
+
+--- Aaron Sloman, 6 Nov 2006
+	Stopped it reading in image files encoded as QP e.g. tiff
+
+--- Aaron Sloman, 1 Oct 2006
+	Modified to allow things like
+		X-Attachment-Id: f_esryfy1c
+--- Aaron Sloman, May 29 2006
+		Added odttype, odptype, odstype, and removed some junk relating to
+		StarOffice types.
+--- Aaron Sloman, May 29 2006
+		Removed pcvtypes
 --- Aaron Sloman, Jul 11 2005
 		Added jar type.
 --- Aaron Sloman, Jun  9 2004
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_reply.p v15.6301-amd64/pop/packages/vedmail/auto/ved_reply.p
--- pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_reply.p	2007-01-30 12:18:32.000000000 -0500
+++ v15.6301-amd64/pop/packages/vedmail/auto/ved_reply.p	2009-07-07 17:17:39.000000000 -0400
@@ -1,5 +1,5 @@
-/* --- Copyright University of Birmingham 2007. All rights reserved. ------
- > File:            $poplocal/local/auto/ved_reply.p
+/* --- Copyright University of Birmingham 2009. All rights reserved. ------
+ > File:            $usepop/pop/packages/vedmail/auto/ved_reply.p
  > Purpose:			Reply to email message
  > Author:          Aaron Sloman, Updated Sept 1994 (see revisions)
  > Documentation:	See below
@@ -135,14 +135,18 @@
 define lconstant vedgetrest(string) -> string with_props 601;
 	;;; used to get continuation of "To:" or "CC:" line, etc.
 	;;; if next line starts with space or tab
-	lvars string, line;
+	lvars string, line, strings;
 	prune_leader(string) -> string;
 	repeat
 		vednextline();
 		vedthisline() -> line;
 	quitif(vvedlinesize == 0 or strmember(`:`,line)
 			or not(strmember(line(1),'\s\t')));
-		string  sys_>< prune_leader(line) -> string
+	sysparse_string(string) <> sysparse_string(line) -> strings;
+	destpair(strings) -> (string, strings);
+	for line in strings do
+		string  sys_>< vedspacestring sys_>< line -> string
+	endfor;
 	endrepeat;
 enddefine;
 
@@ -154,7 +158,7 @@
 	vedjumpto(lo,1);
 	repeat
 		if vvedlinesize == 0 then false -> found; return() endif;
-		vedthisline() -> found;
+		veddecodetabs(vedthisline()) -> found;
 		if isstring(string) then
 			returnif(isstartstring(string, found));
 		else ;;; string must be a list of strings...
@@ -239,6 +243,8 @@
 		else
 			'Subject: Re: ' sys_>< allbutfirst(9, subject) -> subject
 		endif;
+		vedgetrest(subject) -> subject;
+		;;; Veddebug(subject);
 	else 'Subject: ' -> subject
 	endif
 enddefine;
@@ -296,7 +302,9 @@
 		;;; extract the string and if appropriate, the key
 		if ispair(key) then destpair(field) ->(key, field) endif;
 		;;; remove field stuff from beginning of string
-		allbutfirst(datalength(key), field) -> field
+		allbutfirst(datalength(key), field) -> field;
+    	;;; see if there is a continuation
+	 	vedgetrest(field) -> field;
 	endif;
 	;;; Veddebug([key ^key field ^field]);
 enddefine;
@@ -308,7 +316,7 @@
 enddefine;
 
 define lconstant vedgetreferences(lo,hi) -> references;
-	;;; Get subject from line 'Subject: ...   '
+	;;; Get references from line 'References: ...   '
 	lvars lo,hi,references;
 	vedgetfield(ved_references_field , lo, hi) -> references;
 	;;; Veddebug([references ^references]);
@@ -375,6 +383,7 @@
 		endif;
 	else false -> Cc
 	endif;
+
 	;;; Veddebug(Cc);
 	;;; Find where to start reply
 	if Where = '@t' then lo
@@ -398,7 +407,8 @@
 		unless vvedlinesize == 0 then vedlinebelow() endunless
 	endif;
 	unless vedline==1 then vedlinebelow() endunless;
-	unless vedline >= vvedbuffersize then vedlinebelow(); vedcharup();
+	unless vedline >= vvedbuffersize then
+		vedlinebelow(); vedlinebelow(); vedcharup();
 	endunless;
 	;;; insert 'From ' line to conform to mail format.
 	vedcheck();
@@ -420,18 +430,23 @@
 	vedlinebelow(); vedinsertstring(subject);
 
 	;;; insert messageid
-	vedlinebelow();
-	vedinsertstring(ved_inreplyfield); vedinsertstring(messageid);
+	if messageid then
+		vedlinebelow();
+		vedinsertstring(ved_inreplyfield); vedinsertstring(messageid);
+	endif;
+
 	;;; insert references
-	vedlinebelow();
-	vedinsertstring(ved_references_field);
+	if messageid or references /== nullstring then
+		vedlinebelow();
+		vedinsertstring(ved_references_field);
 		unless datalength(references) == 0 then
-			;;; this may be a null string
 			vedinsertstring(references);
 			vedcharright();
 		endunless;
 		;;; make sure at least messageid is in references field.
-		vedinsertstring(messageid);
+		if messageid then vedinsertstring(messageid) endif;
+
+	endif;
 
 	if Cc then
 		;;; insert copy list
@@ -466,10 +481,10 @@
 				vedtextright(); vedcheck(); vedrefreshrange(vedline,vedline,undef);
 			endif;
 		endif;
-		vedcharup(); vedtextright()
+		vedcharup(); vedtextright();vedmarkhi();
 	endif;
 	if oldc then oldc + 1 else 1 endif -> vedchanged;
-	chain(ved_mcm);
+	chain(ved_mcm<>vedrefresh);
 enddefine;
 
 define global vars procedure ved_reply =
@@ -485,6 +500,11 @@
 nil -> proglist;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jul  7 2009
+	Altered to cope with 'wrapped' Subject line.
+--- Aaron Sloman, Feb  7 2007
+	Fixed some problems with continuation lines, and dealt with missing
+	references field	
 --- Aaron Sloman, Jan 30 2007
 	Altered to insert In-Reply-To: field and References: field
 	(Users who don't want them can delete them before sending.)
@@ -543,4 +563,24 @@
 	Simplified vedgetsubject. Made it insert "Re:" after subject, if
 	it isn't already there. Used pdr_valof
 
+         CONTENTS - (Use <ENTER> g to access required sections)
+
+ define lconstant charsbetween(start,fin,string) with_props 501;
+ define lconstant prune_leader(string) -> string;
+ define lconstant prunesitename(string) -> string with_props 505;
+ define lconstant Veddo(vedcommand) with_props 600;
+ define lconstant vedgetrest(string) -> string with_props 601;
+ define lconstant vedtryfind(string,lo,hi) -> found with_props 602;
+ define lconstant vedgetsender(lo,hi) -> line with_props 603;
+ define lconstant vedgetsubject(lo,hi) -> subject with_props 604;
+ define lconstant vedgetCc(lo,hi,) -> Cc with_props 605;
+ define lconstant vedgetTo(lo,hi,) -> string with_props 606;
+ define lconstant vedgetfield(key, lo, hi) -> field;
+ define lconstant vedgetmesssageid(lo,hi) -> messageid;
+ define lconstant vedgetreferences(lo,hi) -> references;
+ define lconstant vedtry(proc,lo,hi);
+ define lconstant veddoreply(all_?) with_props ved_reply;
+ define global vars procedure ved_reply =
+ define global vars procedure ved_Reply =
+
  */
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_respond.p v15.6301-amd64/pop/packages/vedmail/auto/ved_respond.p
--- pp0/v15.61-amd64/pop/packages/vedmail/auto/ved_respond.p	2003-08-02 12:13:31.000000000 -0400
+++ v15.6301-amd64/pop/packages/vedmail/auto/ved_respond.p	2009-07-07 18:48:57.000000000 -0400
@@ -1,5 +1,5 @@
-/* --- Copyright University of Birmingham 2003. All rights reserved. ------
- > File:            $poplocal/local/auto/ved_respond.p
+/* --- Copyright University of Birmingham 2009. All rights reserved. ------
+ > File:            $usepop/pop/packages/vedmail/auto/ved_respond.p
  > Purpose:			Reply to message, quoting it indented.
  > Author:          Aaron Sloman, Feb  6 1992 (see revisions)
  > Documentation:	HELP * VED_GETMAIL
@@ -41,10 +41,20 @@
 	ved_mcm();
 	vedmarklo();
 	unless arg = nullstring then
+		;;; use arg to set 'quotation indicator'
 		'gsr/@a/' <> arg <> ' /' -> commandstring
 	endunless;
 	veddo(commandstring);
 	ved_mcm();
+	vedpositionpush();
+	vedendrange();
+	;;; add a line
+	vedlinebelow();
+	;;; unmark new line
+	vedcharup(); vedmarkhi();
+	;;; go back
+	vedpositionpop();
+
 	;;; move range off From line
 	vvedmarklo+1 -> vvedmarklo;
 	chain(vedrefresh);
@@ -59,6 +69,9 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jul  7 2009
+		add unmarked blank line at end of new message, to avoid
+		marked range commands affecting next message.
 --- Aaron Sloman, Aug  2 2003
 	Made to cal ved_mcm at end
 --- Aaron Sloman, Jul 11 1992
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/packages/vedutils/auto/ved_jlp.p v15.6301-amd64/pop/packages/vedutils/auto/ved_jlp.p
--- pp0/v15.61-amd64/pop/packages/vedutils/auto/ved_jlp.p	1999-05-23 08:17:00.000000000 -0400
+++ v15.6301-amd64/pop/packages/vedutils/auto/ved_jlp.p	2008-06-12 11:46:45.000000000 -0400
@@ -1,4 +1,4 @@
-/* --- Copyright University of Birmingham 1999. All rights reserved. ------
+/* --- Copyright University of Birmingham 2008. All rights reserved. ------
  > File:            $poplocal/local/ved_latex/auto/ved_jlp.p
  > File:            $poplocal/local/auto/ved_jlp.p
  > Purpose:			justify paragraph in .tex files specially
@@ -28,9 +28,9 @@
 
 global vars non_latex_para_breaks;
 unless isstring(non_latex_para_breaks) then
-	;;; use '.' at begining of line as an indication that line should not
-	;;; be joined, as in nroff/troff files.
-	'.' -> non_latex_para_breaks
+	;;; use '.' or '>' at begining of line as an indication that line should not
+	;;; be joined, as in nroff/troff files and mail files with quotes.
+	'>.' -> non_latex_para_breaks
 endunless;
 
 
@@ -69,7 +69,7 @@
 		until vedline == vvedbuffersize or vvedlinesize == 0 or formatline() do
 			vedchardown();
 			if isstartstring('Received: ', vedthisline()) then
-				Veddebug('In mail header. Are you sure?')
+				veddebug('In mail header. Are you sure?')
 			endif;
 		enduntil;
 		if vvedlinesize == 0 or formatline() then vedcharup() endif;
@@ -87,6 +87,8 @@
 endsection;
 
 /* --- Revision History ---------------------------------------------------
+--- Aaron Sloman, Jun 12 2008
+		Replaced 'Veddebug' with 'veddebug'
 --- Aaron Sloman, May 23 1999
 	Extended to work better with teach files ending in .p
 --- Aaron Sloman, Mar 24 1999
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/aextern.s v15.6301-amd64/pop/src/aextern.s
--- pp0/v15.61-amd64/pop/src/aextern.s	2005-03-11 05:30:39.000000000 -0500
+++ v15.6301-amd64/pop/src/aextern.s	2010-01-03 05:55:39.000000000 -0500
@@ -187,6 +187,16 @@
 	leaq	8(%rsp), %rbp
 	movq	%rbp, SAVED_SP
 
+        ;;; save registers.  XXXX What to do about garbage collection
+        ;;; of Pop values ???
+        push    %r8
+        push    %r10
+        push    %r11
+        push    %r12
+        push    %r13
+        push    %r14
+        push    %r15
+
 	;;; Load fixed arguments
 
 	movq	(%USP), %r12	;;; _________fltsingle
@@ -203,6 +213,7 @@
 ;;;     fits into a register this gives 3+nargs, push allocate 1
 ;;;     so we put another two into alignment code
 
+        subq    $56, %rbp
         push    %r10
         xorq    %r14, %r14
         subq    %r15, %rsp       ;;; allocate space for arguments
@@ -347,6 +358,13 @@
 
 	movq	SAVED_SP, %rax
         movq    (%rax), %rbp
+        movq    -16(%rax), %r8
+        movq    -24(%rax), %r10
+        movq    -32(%rax), %r11
+        movq    -40(%rax), %r12
+        movq    -48(%rax), %r13
+        movq    -56(%rax), %r14
+        movq    -64(%rax), %r15
 	leaq	-8(%rax), %rsp
 	movq	$0, SAVED_SP		;;; Indicates external call over
 
@@ -527,6 +545,26 @@
 	.align  16
 
 
+EXTERN_NAME(pop_print):
+#_IF CHECK_BREAK
+
+        ;;; Save the current break so that callback code has correct
+        ;;; info 
+
+        movq    EXTERN_NAME(___brk_addr), %rax
+        movq    %rax, save_curbrk
+        movl    $0, %eax
+#_ENDIF
+    movq %rdi, SAVED_SP
+    movq %rsi, SAVED_USP
+    pushq %rdx
+    movq $C_LAB(sys_syspr), %rdi
+    movq %rsp, %rsi
+    call pop_call
+    addq $8, %rsp
+    ret
+    .align  16
+
 	.data
 
 #_IF CHECK_BREAK
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/amain.s v15.6301-amd64/pop/src/amain.s
--- pp0/v15.61-amd64/pop/src/amain.s	2005-03-11 05:30:39.000000000 -0500
+++ v15.6301-amd64/pop/src/amain.s	2009-12-25 02:56:37.000000000 -0500
@@ -59,6 +59,14 @@
 
 	movq    %rsi,  I_LAB(Sys$- _init_args)
 
+#_IF DEF LINUX
+
+        ;;; set personality
+
+        call linux_setper
+
+#_ENDIF
+
 	;;; Initialise the floating-point unit
 
 	call	fpu_init
@@ -67,8 +75,12 @@
 
 	movq	SAVED_USP, %USP
 
-	;;; Start the system
-
+	;;; clear Pop registers
+        movq    $3, %r13
+        movq    $3, %r14
+        movq    $3, %r15
+        
+        ;;; Start the system
 	call	XC_LAB(setpop)
 
 	;;; Exit with 0
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/amisc.s v15.6301-amd64/pop/src/amisc.s
--- pp0/v15.61-amd64/pop/src/amisc.s	2005-03-11 05:30:39.000000000 -0500
+++ v15.6301-amd64/pop/src/amisc.s	2009-12-27 15:49:45.000000000 -0500
@@ -17,7 +17,8 @@
 
 constant
 	procedure (Call_overflow, User_overflow, Callstack_reset,
-	Conspair, Plog$-Area_overflow, Async_raise_signal)
+	Conspair, Plog$-Area_overflow, Async_raise_signal,
+        dummy_procedure_callback_helper)
 	;
 
 endsection;
@@ -42,6 +43,14 @@
 
 );
 
+lconstant macro MOVFL   = if DEF FRAME_LEN_16BIT then "movzwl"
+                          elseif DEF FRAME_LEN_32BIT then "movl"
+                          else "movzbl"
+                          endif;
+
+lconstant macro RAX = if DEF FRAME_LEN_32BIT then "eax" else "rax" endif;
+lconstant macro RCX = if DEF FRAME_LEN_32BIT then "ecx" else "rcx" endif;
+
 >_#
 
 	.file	"amisc.s"
@@ -261,7 +270,7 @@
 	;;; Find the length of the frame (in longwords) from the owner's
 	;;; procedure header
 
-	movzbq	_PD_FRAME_LEN(%rcx), %rcx
+	MOVFL	_PD_FRAME_LEN(%rcx), %ecx
 
 	;;; Add the frame length in bytes (ECX * 4) to the given frame
 	;;; pointer to get the next frame pointer.
@@ -298,7 +307,7 @@
 	;;; Extract the length of the previous stack frame (in longwords)
 	;;; from its owner procedure, whose address should be in PB
 
-	movzbq	_PD_FRAME_LEN(%PB), %rax
+	MOVFL	_PD_FRAME_LEN(%PB), %eax
 
 	;;; The last word in that frame will be the return address:
 	;;; copy that to CHAIN_REG, then replace it with our return
@@ -1006,6 +1015,31 @@
 
 	.align  16
 
+        .data
+mess33:
+        .string "sp = 0x%lx\\n"
+
+        .text
+EXTERN_NAME(pop_print_sp):
+        movq    $mess33, %rdi
+        movq    %rsp, %rsi
+        movl    $0, %eax
+        call    printf
+        ret
+
+/*
+EXTERN_NAME(pop_print):
+        pushq %rbp
+        mov XC_LAB(Sys$-dummy_procedure_callback_helper),%rbp
+        pushq %rbp
+        subq    $8, %USP
+        movq    %rdi, (%USP)
+        call     XC_LAB(sys_syspr)
+        popq %rbp
+        popq %rbp
+        ret
+        .align  16
+*/
 
 /***************** end labels for wrapping structures *****************/
 
diff -ru --exclude=CVS --exclude='*index' --exclude=basepop11.map --exclude=ref --exclude=help --exclude=teach pp0/v15.61-amd64/pop/src/aprocess.s v15.6301-amd64/pop/src/aprocess.s
--- pp0/v15.61-amd64/pop/src/aprocess.s	2005-03-11 05:30:39.000000000 -0500
+++ v15.6301-amd64/pop/src/aprocess.s	2009-12-24 15:36:33.000000000 -0500
@@ -31,6 +31,11 @@
 	_PS_STATE		= @@PS_STATE,
 );
 
+lconstant macro MOVFL   = if DEF FRAME_LEN_16BIT then "movzwl"
+                          elseif DEF FRAME_LEN_32BIT then "movl"
+                          else "movzbl"
+                          endif;
+
 >_#
 
 	.file	"aprocess.s"
@@ -107,7 +112,7 @@
 	;;; record; we compute the position of the next frame by subtracting
 	;;; the length of the current stack frame
 
-	movzbq	_PD_FRAME_LEN(%PB), %rax
+	MOVFL	_PD_FRAME_LEN(%PB), %eax
 	salq	$3, %rax
 	subq	%rax, %rdi
 	movq	%rdi, NEXT_FRAME
@@ -122,7 +127,7 @@
 	;;; Copy any on-stack lvars into the process record
 
 	cld
-	movzbq	_PD_NUM_STK_VARS(%PB), %rcx
+	MOVFL	_PD_NUM_STK_VARS(%PB), %ecx
 	leaq	8(%rsp), %rsi
 	rep
 	smovq
@@ -130,7 +135,7 @@
 
 	;;; Test if there are any dynamic locals
 
-	movzbq	_PD_NLOCALS(%PB), %rcx
+	MOVFL	_PD_NLOCALS(%PB), %ecx
 	cmpq	$0, %rcx
 	je	L2.1
 
@@ -253,7 +258,7 @@
 	;;; Compute the position of the next frame in the record by adding
 	;;; the length of the current frame
 
-	movzbq	_PD_FRAME_LEN(%PB), %rax
+	MOVFL	_PD_FRAME_LEN(%PB), %eax
 	leaq	(%rsi, %rax, 8), %rsi
 	movq	%rsi, NEXT_FRAME
 	subq	$8, %rsi
@@ -261,7 +266,7 @@
 	;;; Check for any dynamic locals
 
 	std
-	movzbq	_PD_NLOCALS(%PB), %rcx
+	MOVFL	_PD_NLOCALS(%PB), %ecx
 	cmpq	$0, %rcx
 	je	L2.2
 
@@ -283,7 +288,7 @@
 L2.2:	;;; Copy any on-stack lvars from the saved frame,
 	;;; adjusting ESP first in case of interrupts
 
-	movzbq	_PD_NUM_STK_VARS(%PB), %rcx
+	MOVFL	_PD_NUM_STK_VARS(%PB), %ecx
 	leaq	-8(%rsp), %rdi
 
 	leaq	(, %rcx, 8), %rax
